
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CapasDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const capas = await db.capas.create(
            {
                id: data.id || undefined,
        
        capa_number: data.capa_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        problem_statement: data.problem_statement
        ||
        null
            ,
            
        root_cause: data.root_cause
        ||
        null
            ,
            
        corrective_action: data.corrective_action
        ||
        null
            ,
            
        preventive_action: data.preventive_action
        ||
        null
            ,
            
        due_at: data.due_at
        ||
        null
            ,
            
        closed_at: data.closed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await capas.setPlant( data.plant || null, {
            transaction,
        });
        
        await capas.setNonconformance( data.nonconformance || null, {
            transaction,
        });
        
        await capas.setOwner_user( data.owner_user || null, {
            transaction,
        });
        
        await capas.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.capas.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: capas.id,
            },
            data.attachments,
            options,
        );
        

        return capas;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const capasData = data.map((item, index) => ({
                id: item.id || undefined,
                
                capa_number: item.capa_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                problem_statement: item.problem_statement
            ||
            null
            ,
            
                root_cause: item.root_cause
            ||
            null
            ,
            
                corrective_action: item.corrective_action
            ||
            null
            ,
            
                preventive_action: item.preventive_action
            ||
            null
            ,
            
                due_at: item.due_at
            ||
            null
            ,
            
                closed_at: item.closed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const capas = await db.capas.bulkCreate(capasData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < capas.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.capas.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: capas[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return capas;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const capas = await db.capas.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.capa_number !== undefined) updatePayload.capa_number = data.capa_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.problem_statement !== undefined) updatePayload.problem_statement = data.problem_statement;
        
        
        if (data.root_cause !== undefined) updatePayload.root_cause = data.root_cause;
        
        
        if (data.corrective_action !== undefined) updatePayload.corrective_action = data.corrective_action;
        
        
        if (data.preventive_action !== undefined) updatePayload.preventive_action = data.preventive_action;
        
        
        if (data.due_at !== undefined) updatePayload.due_at = data.due_at;
        
        
        if (data.closed_at !== undefined) updatePayload.closed_at = data.closed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await capas.update(updatePayload, {transaction});

        
        
        if (data.plant !== undefined) {
            await capas.setPlant(
              
              data.plant,
              
              { transaction }
            );
        }
        
        if (data.nonconformance !== undefined) {
            await capas.setNonconformance(
              
              data.nonconformance,
              
              { transaction }
            );
        }
        
        if (data.owner_user !== undefined) {
            await capas.setOwner_user(
              
              data.owner_user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await capas.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.capas.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: capas.id,
            },
            data.attachments,
            options,
        );
        

        return capas;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const capas = await db.capas.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of capas) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of capas) {
                await record.destroy({transaction});
            }
        });


        return capas;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const capas = await db.capas.findByPk(id, options);

        await capas.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await capas.destroy({
            transaction
        });

        return capas;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const capas = await db.capas.findOne(
            { where },
            { transaction },
        );

        if (!capas) {
            return capas;
        }

        const output = capas.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.plant = await capas.getPlant({
            transaction
        });
        
        
        output.nonconformance = await capas.getNonconformance({
            transaction
        });
        
        
        output.owner_user = await capas.getOwner_user({
            transaction
        });
        
        
        output.attachments = await capas.getAttachments({
            transaction
        });
        
        
        output.organizations = await capas.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.plants,
        as: 'plant',
        
        where: filter.plant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.plant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.plant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.nonconformances,
        as: 'nonconformance',
        
        where: filter.nonconformance ? {
          [Op.or]: [
            { id: { [Op.in]: filter.nonconformance.split('|').map(term => Utils.uuid(term)) } },
            {
              ncr_number: {
                [Op.or]: filter.nonconformance.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner_user',
        
        where: filter.owner_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.capa_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capas',
                        'capa_number',
                        filter.capa_number,
                    ),
                };
            }
            
            if (filter.problem_statement) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capas',
                        'problem_statement',
                        filter.problem_statement,
                    ),
                };
            }
            
            if (filter.root_cause) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capas',
                        'root_cause',
                        filter.root_cause,
                    ),
                };
            }
            
            if (filter.corrective_action) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capas',
                        'corrective_action',
                        filter.corrective_action,
                    ),
                };
            }
            
            if (filter.preventive_action) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capas',
                        'preventive_action',
                        filter.preventive_action,
                    ),
                };
            }
            

            
            

            
            if (filter.due_atRange) {
                const [start, end] = filter.due_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.closed_atRange) {
                const [start, end] = filter.closed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.capas.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'capas',
                        'capa_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.capas.findAll({
            attributes: [ 'id', 'capa_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['capa_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.capa_number,
        }));
    }

    
};

